$("#map").bind("completeMap",function(e){
	//Llevarme al extent si es que lo tengo entre los parametros actuales
	
	if(window.location.search.substr(1).indexOf("extent=")!=-1)
	{
		var values = window.location.search.substr(1).split("&")[0].split("=")[1].split(",");
		map.zoomToExtent(new OpenLayers.Bounds(values[0],values[1],values[2],values[3]));
		
		if(window.location.pathname.endsWith("/cartoArba/"))
			path_result = window.location.pathname;
			else
				if(window.location.pathname.endsWith("/cartoArba"))
					path_result = window.location.pathname + "/";
					else
						path_result = window.location.pathname;
		
		window.history.pushState({urlPath:window.location.pathname},"",path_result);
	}	
});


/*
 * /////////////////////// Eventos que despacha este JS ///////////////////////////////////////////////////////
 * 
 * startApp			:: Cuando la aplicacion es cargada
 * moveend(map)		:: Cuando se termina de mover en el mapa
 * 
 * 
 */



///////////////////////////////// CREACION DEL MAPA //////////////////////////////////////////////////////
var map;
//var restrict_extent = new OpenLayers.Bounds(-7156871.5,-5117696.5,-6207815.5,-3830408.25);
var restrict_extent = new OpenLayers.Bounds(-7754299, -5120479, -5731505, -3771101);
var extent = new OpenLayers.Bounds(-9015492,-8369427,-3997040,-2038803);

var MM_countTailFaild = 0;

var MM_IS_TRANSPARENT_MAP = false;
var MM_nomencla_selected = "";

map = new OpenLayers.Map('map', {
	projection: 'EPSG:900913',
	maxResolutions: 2445.9849047851562,
	resolutions:[/*156543.03390625,78271.516953125,39135.7584765625,19567.87923828125,9783.939619140625,4891.9698095703125,*/2445.9849047851562,1222.9924523925781,611.4962261962891,305.74811309814453,152.87405654907226,76.43702827453613,38.218514137268066,19.109257068634033,9.554628534317017,4.777314267158508,2.388657133579254,1.194328566789627,0.5971642833948135,0.2985821416974068,0.1492910708487034,0.0746455354243517,0.0373227677121758,0.0186613838560879,0.009330691928044,0.004665345964022,0.002332672982011,0.0011663364910055,0.0005831682455027,0.0002915841227514,0.0001457920613757],
	//resolutions: [152.8740566, 76.43702829, 38.21851414, 19.10925707, 9.554628536, 4.777314268, 2.388657134, 1.194328567, 0.597164283, 0.29858214, 0.14929107, 0.07564554],
     //numZoomLevels: 12,
	 numZoomLevels: "auto",
	 //fractionalZoom:false,
     units: 'm',
	controls: [
               new OpenLayers.Control.Navigation(),
               //new OpenLayers.Control.ZoomPanel(),
               new OpenLayers.Control.ScaleLine(),
               new OpenLayers.Control.KeyboardDefaults()

           ],
    //       maxResolution: 'auto',
           
    restrictedExtent: restrict_extent
});




$("#map").trigger("startApp");

setTimeout(function(){map.updateSize();},200);


function MM_refresh_page()
{
	window.location='..'+window.location.pathname+'?extent='+map.getExtent().toString();
}


function countTotalTilesActual()
{
	return ((Math.ceil($("#map").width()/256))+1)*(Math.ceil($("#map").height()/256)+1);
}


//Chequea que tenga session pura y exclusivamente en el mapa. 
//Lllamo a servicio checkSession cuando carga 4 tiles erroneos, si retorna true es que tiene session y pone el contador de tiles erroneos MM_countTailFaild en 0
function onloadstartCheckSession(lay)
{
	
	   if ($(".olImageLoadError").size() > 0) {
		   MM_countTailFaild = $(".olImageLoadError").size();
		   
		   if(loginUser!=undefined){
			   
			   
			   if(MM_countTailFaild >= 4)
			   {			   
				   var ram = Math.floor((Math.random() * 1000) + 1);
				   $.ajax({
						  type: "GET",
						  url: "client/checkSession?r="+ram,
						  data: ram,
						  contentType: 'application/json',
						  success: function(data) {
							   if(eval(data).second) 
								   MM_countTailFaild = 0;
							   else
								   MM_refresh_page();
								   
								   
						  },
						  error:function()
						  {
							  console.log("Error check session");
							  MM_refresh_page();
		                  }	
				   });
			   }
		   }
		   else
			    if(MM_countTailFaild > (countTotalTilesActual()*0.7)) //solo hacer esto si no vengo de un reload
			   		MM_refresh_page();
			    	//bootbox.alert("El sitio se encuentra sobrecargado, por favor intente ingresar mas tarde.")
			    	
			    	
			    	
			    	
		   
		   $(".olImageLoadError").attr("src","./resources/img/tile_blank.png");
	    }
	   
	   
	   
}



/**
 * Centra el mapa en el punto x y pasado por parametro, manteniendo el mismo nivel de zoom
 * @param x
 * @param y
 */
function MM_setCenter(x,y)
{
	map.panTo(map.getLonLatFromPixel(new OpenLayers.Pixel(x,y)));
}

function MM_redraw_WMS()
{
	$.each(map.layers, function(index, layer) {
		if(layer.service != ML_EXTERNAL)
			layer.redraw(true);
	});
}

/**
 * Centra el mapa en la latitud y longitud pasada por parametro
 * @param lat latitud
 * @param lon longitud
 */
function MM_setCenterLatLon(lat, lon, epsgFrom)
{
	var center = (new OpenLayers.LonLat(lon,lat)).transform(new OpenLayers.Projection(epsgFrom), new OpenLayers.Projection('EPSG:900913')); 
	map.setCenter(center,18,true,true);
}

/**
 * Retorna la escala actual del mapa 
 */
function MM_getScale()
{
	return map.getScale();
}

function MM_adjustMap()
{

	map.updateSize();
}


//Guarda el zoom actual del mapa para verificar cambios de zoom posteriores
function MM_updatePreviousZoom()
{
	zoomPrev = map.zoom;
}

///////////////////////////////// FUN CREACION DEL MAPA /////////////////////////////////////////////////

///////////////////////////////// MANEJO DE EVENTOS /////////////////////////////////////////////////

var zoomPrev;
map.events.register("zoomend",map, 
function(e) 
{
	
	destroyPopups();
//Evento que cierra la ventana de info ante un cambio de zoom
	if(zoomPrev!=e.object.zoom) //cambio el zoom
		jInfo_closeInfo();
		
	MM_updatePreviousZoom();
	
	loadingPanel.minimizeControl();
	
	$("#map").trigger("zoomend",map);
	
});


// Evento de moveend lo disparamos sobre #map
map.events.register("moveend",map, 
		function(e) 
		{
			$("#map").trigger("moveend",map);
		});

 
/**
 * Agrega una nueva marca en el punto pasado por parametro (usado para mis lugares)
 * @param lonlat
 */


function destroyPopups()
{
	//eliminar popups anteriores
	var pops = map.popups;
	for(var a = 0; a < pops.length; a++){
	   map.removePopup(map.popups[a]);
	};
}




$(document)
.ajaxStart(function () {
	loadingPanel.maximizeControl();
	  
})
.ajaxStop(function () {
	  loadingPanel.minimizeControl();
});


window.onresize=function()
{
	MM_adjustMap();
};



/*$("#map").resize(function() {
	setTimeout(function(){map.updateSize();},200);
});*/







$(window).bind("resize", function(){
	if($(window).width()<=768)
	{
		$("#tools_content").css("left","10px");
		
		$("#contenedor_info").css("left","0px");
		$("#contenedor_info").css("top","0px");
		
	}
	else
	{
		if($("#nav_left_normal").css("display")=="block")
			$("#tools_content").addClass("offset_on_expand").removeClass("offset_on_minimize");
		else
			
			$("#tools_content").addClass("offset_on_minimize").removeClass("offset_on_expand");

		
		setTimeout(function(){
			
			MM_adjustMap();

			//Redibujo las capas WMS porque sino queda una columna de tiles sin cargar a la izquierda
			ML_redrawAllWMS();	
			
		}, 150);
		
	}
	
	
});	

/*$("#map").bind("contextmenu",function(e){
    return false;
});*/





function QuoteEncoding(strvalue) {
    var strquotes = /(')/g;
    return "'" + strvalue.replace(strquotes, "\'") + "'";
}







///////////////////////////////// FIN MANEJO DE EVENTOS /////////////////////////////////////////////////



//setea el valor de la nomencla seleccionada actual
function MM_selectNomencla(value)
{
	if(typeof value == "undefined")
		return MM_nomencla_selected;
	else
		MM_nomencla_selected = value;
}


function MM_GO_TO_SSO()
{
	window.location="/cartoArba/login?extent="+map.getExtent().toString();
}


/**/





$(document).ready(function(){

	document.body.addEventListener('click', function(){
		
		if($("#tools_navbar").find(".open").length>0)
			$("#tools_navbar").find(".open").removeClass("open");
		
	}, true); 

});	




